<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.servlet.ControllerServlet" %>
<%@ page import="com.lombardisoftware.servlet.util.MimeTypeUtils" %>

<%
    // To prevent XSS attack we could escape the content, but per design it is already escaped. To avoid
    // the data being escaped twice and to prevent XSS attack at the same time, we do not allow a user
    // to force the content type. We resolve MIME type based on file extension and if it is considered
    // as other than downloadable, cancel the request.

    String fileName = request.getParameter("fileName");
    String mimeType = MimeTypeUtils.getMimeTypeForDownloadableData(fileName);

    if (mimeType == null) {
    	// If the content is not a csv, throw and error and don't add any data or type
        ControllerServlet.processError(request, response, new ServletException("Content type cannot be resolved"));
    } else {
		// If the content is a csv, then add in the type and the data
        String dateInput = request.getParameter("data");

        if(dateInput.matches("(?is).*lt;[\\s]*script.*|.*\\<[\\s]*script.*|.*\\%3C[\\s]*script.*")){
            ControllerServlet.processError(request, response, new ServletException("Content data contains possible script injection.")); 
        } else {
            response.setContentType(mimeType + "; charset=utf-8");
            response.addHeader("Content-Disposition", fileName);
            response.getWriter().print(dateInput);
        }
    }
%>
