<%@page import="com.ibm.bpm.endpoint.EndpointService"%>
<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.core.TWHttpClient,
                 com.lombardisoftware.core.config.TWConfiguration,
                 com.lombardisoftware.utility.ApplicationServerPlatform,
                 com.lombardisoftware.utility.Base64Encoder,
                 com.lombardisoftware.core.TeamWorksRuntimeException,
                 java.net.URLEncoder" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%
	String username = null;
	String password = null;
    if (TWConfiguration.getInstance().getAuthoringEnvironment().isAddRedirectUrlCredentials()) {
        if (TWConfiguration.getInstance().getAuthoringEnvironment().isEncodeRedirectUrlCredentials()) {
			String credentials = request.getParameter("credentials");
			if (credentials != null) {
			    int pos = credentials.indexOf(":");
				try {
					if (pos == -1) {
						username = new String(Base64Encoder.base64ToByteArray(credentials), "UTF-8");
					} else {
						username = new String(Base64Encoder.base64ToByteArray(credentials.substring(0, pos)), "UTF-8");
						password = new String(Base64Encoder.base64ToByteArray(credentials.substring(pos + 1)), "UTF-8");
					}
			    } catch(java.io.UnsupportedEncodingException e) {
			    	throw TeamWorksRuntimeException.asTeamWorksRuntimeException(e);
			    }
		    } else {
                username = request.getParameter("j_username");
                password = request.getParameter("j_password");
            }
        } else {
		    username = request.getParameter("j_username");
		    password = request.getParameter("j_password");
        }
    }
	if ("".equals(password)) password = null;

	com.ibm.bpm.crconfig.BPMContextRootConfigService ctxRootService = com.ibm.bpm.crconfig.BPMContextRootConfigServiceFactory.getInstance().getContextRootConfigService();
        
	String redirectTo = request.getParameter("j_forward");
	if (redirectTo != null) {
		redirectTo = redirectTo.replace('|', '&');
		String teamworksContext = ctxRootService.getContextRoot("teamworks.war");
		if (redirectTo.startsWith("/")) {
			redirectTo = teamworksContext + redirectTo;
		} else {
			redirectTo = teamworksContext + "/" + redirectTo;
		}
        
	    // If we are going to download managed asset
        // we need to encode filename which may contain international symbols
        if (redirectTo.contains("webasset/")) {
        	int slashpos = redirectTo.lastIndexOf("/");
        	if (slashpos > -1 && slashpos < redirectTo.length() - 1) {
        		String filename = redirectTo.substring(slashpos + 1);
        		redirectTo = redirectTo.substring(0, slashpos + 1) + URLEncoder.encode(filename, "UTF-8");
        	}
        } 
		
		// Add redirect cookie
		Cookie cookie = new Cookie("TWforwardPage", redirectTo);
		response.addCookie(cookie);
    }
	
    Cookie [] cookies = request.getCookies();
    if (cookies != null) {
	    for (int i = 0; i < cookies.length; i++) {
	        Cookie cookie = cookies[i];
	        if ((cookie != null) && cookie.getName().equals("JSESSIONID")) {
	            cookie.setMaxAge(0);
	            response.addCookie(cookie);
	        }
	        if ((cookie != null) && (redirectTo == null) && cookie.getName().equals("TWforwardPage")) {
				redirectTo = cookie.getValue();
			}
	    }
    }
	if (session!=null) session.invalidate();

    if ((username != null) && (password != null)) {
    	// make credentials available for JSTL (fn:escapeXml)
    	pageContext.setAttribute("username", username);
    	pageContext.setAttribute("password", password);
%>
<html>
    <head>
        <title>Redirect Login</title>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <script>
			function setCookie(name, value, expires, path, domain, secure) {
				 var curCookie = name + "=" + escape(value) +
				  ((expires) ? "; expires=" + expires.toGMTString() : "") +
				  ((path) ? "; path=" + path : "") +
				  ((domain) ? "; domain=" + domain : "") +
				  ((secure) ? "; secure" : "");
				 document.cookie = curCookie;
			}
		
			try {
			    setCookie("ibm.bpm.timezoneOffset", new Date().getTimezoneOffset(), null, "/");
			} catch(ex) { }
		</script>
    </head>
    <body onLoad="document.login.submit()">
        <form method="POST" action="j_security_check" name="login">
            <input type="hidden" name="j_username" value="${fn:escapeXml(username)}">
            <input type="hidden" name="j_password" value="${fn:escapeXml(password)}">
        </form>
    </body>
</html>
<%
	} else {
		String remoteUser = request.getRemoteUser();
		if ((username != null) && (remoteUser != null) && !username.equals(remoteUser)) {
			// we are changing users so need to log out the current user
			String logoutExitPage = "redirect-login.jsp";
			logoutExitPage = logoutExitPage + "?credentials=" + request.getParameter("credentials");
%>
<html>
    <head>
        <title>Redirect Login</title>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    </head>
    <body onLoad="document.logoutForm.submit()">
        <form method="POST" action="ibm_security_logout" name="logoutForm">
	        <input type="hidden" name="logout" value="Logout">
	        <input type="hidden" name="logoutExitPage" value="<%=logoutExitPage%>">
        </form>
    </body>
</html>
<%			
		} else {
			request.getSession().setAttribute("origin", redirectTo);
			if (username != null) {
				Cookie cookie = new Cookie("username", username);
				response.addCookie(cookie);
			}
			response.sendRedirect(request.getContextPath() + "/pushTZCookie.jsp");
		}
	}
%>
